<cffunction name="execute" output="false" access="public" returntype="boolean" hint="I execute this command">
	<cfargument name="KalendarEvent" type="any" required="true"/>
	<cfargument name="UserMsg" type="any" required="true" >
	
	 <cftransaction action="begin">
	<!--- validate the passed arguments --->
	<cfif getValidator().validate( argumentcollection=arguments ) >

		<!--- See if we need to add a category --->
		<cfif arguments.KalendarEvent.hasNewCategory() >
			<cfset arguments.KalendarEvent.setCategoryID( getCategoryService().saveNewCategory( arguments.KalendarEvent.getNewCategoryName() ) )>
			<!--- This function uses ducktyping. The KalendarEvent cfc functions as a CategoryBean --->
			<cfif val( arguments.KalendarEvent.getCategoryID() ) >
				<cfset arguments.UserMsg.addSuccess("New Category Added!") />
			<cfelse>
				<!--- Ok, that didn't work. Make a note of it and just get out of this function. --->
				<cfset arguments.UserMsg.addError("Adding New Category Failed!") />
				<cfreturn false />
			</cfif>
		</cfif>
		
		<!--- Try to add the record --->
		<cfif getKalendarDAO().save( arguments.KalendarEvent ) >
			<cfset arguments.UserMsg.addSuccess("New Event Added") />
		<cfelse>
			<!--- Adding the record didnt' work. Make a note of it and just get out of this function. --->
			<cfset arguments.UserMsg.addError("Adding New Event Failed") />
			<cfreturn false />
		</cfif>
	
	<cfelse>
		<cfreturn false />
	</cfif>

	</cftransaction>
	
	<cfreturn true />
	
</cffunction>

<!--- Calling function --->
<cfset result =  KalendarService.loadCommand( DeleteUser )
		.execute( CategoryBean, UserMsg) />
