		
		<cfcase value="createRecord">
		<cfsilent>
		<cfif Len(Trim(form.NewCategoryName))>
			<cfinvoke component="#application.CFCPath#kalendarCategories" method="createRecord" returnvariable="returnedCreateCategory">
				<cfinvokeargument name="CategoryName" value="#form.NewCategoryName#" />
			</cfinvoke>
			<cfset form.CategoryID = returnedCreateCategory.NewCategoryID />
		</cfif>
		<cfif NOT Len(Trim(form.EndDate))>
			<cfset form.EndDate = form.StartDate />
		</cfif>
		<cfinvoke component="#application.CFCPath#kalendar" method="createRecord" returnvariable="returnMessage">
			<cfinvokeargument name="EventID" value="#form.EventID#" />
			<cfinvokeargument name="CategoryID" value="#form.CategoryID#" />
			<cfinvokeargument name="IsFeatured" value="#form.IsFeatured#" />
			<cfinvokeargument name="IsPublished" value="#form.IsPublished#" />
			<cfinvokeargument name="StartDate" value="#form.StartDate#" />
			<cfinvokeargument name="EndDate" value="#form.EndDate#" />
			<cfinvokeargument name="StartTime" value="#form.StartTime#" />
			<cfinvokeargument name="EndTime" value="#form.EndTime#" />
			<cfinvokeargument name="Title" value="#form.Title#" />
			<cfinvokeargument name="Location" value="#form.Location#" />
			<cfinvokeargument name="ExternalURL" value="#form.ExternalURL#" />
			<cfinvokeargument name="ContactName" value="#form.ContactName#" />
			<cfinvokeargument name="ContactEmail" value="#form.ContactEmail#" />
			<cfinvokeargument name="ContactPhone" value="#form.ContactPhone#" />
			<cfinvokeargument name="Teaser" value="#form.Teaser#" />
			<cfinvokeargument name="Description" value="#form.Description#" />
		</cfinvoke>
		<cflocation url="#cgi.SCRIPT_NAME#?appAction=addRecord&returnMessage=#URLEncodedFormat(returnMessage)#" addtoken="false" />
		</cfsilent>
		</cfcase>
		
		<cfcase value="updateRecord">
		<cfsilent>
		<cfif Len(Trim(form.NewCategoryName))>
			<cfinvoke component="#application.CFCPath#kalendarCategories" method="createRecord" returnvariable="returnedCreateCategory">
				<cfinvokeargument name="CategoryName" value="#form.NewCategoryName#" />
			</cfinvoke>
			<cfset form.CategoryID = returnedCreateCategory.NewCategoryID />
		</cfif>
		<cfif NOT Len(Trim(form.EndDate))>
			<cfset form.EndDate = form.StartDate />
		</cfif>
		<cfinvoke component="#application.CFCPath#kalendar" method="updateRecord" returnvariable="returnMessage">
			<cfinvokeargument name="EventID" value="#form.EventID#" />
			<cfinvokeargument name="CategoryID" value="#form.CategoryID#" />
			<cfinvokeargument name="IsFeatured" value="#form.IsFeatured#" />
			<cfinvokeargument name="IsPublished" value="#form.IsPublished#" />
			<cfinvokeargument name="StartDate" value="#form.StartDate#" />
			<cfinvokeargument name="EndDate" value="#form.EndDate#" />
			<cfinvokeargument name="StartTime" value="#form.StartTime#" />
			<cfinvokeargument name="EndTime" value="#form.EndTime#" />
			<cfinvokeargument name="Title" value="#form.Title#" />
			<cfinvokeargument name="Location" value="#form.Location#" />
			<cfinvokeargument name="ExternalURL" value="#form.ExternalURL#" />
			<cfinvokeargument name="ContactName" value="#form.ContactName#" />
			<cfinvokeargument name="ContactEmail" value="#form.ContactEmail#" />
			<cfinvokeargument name="ContactPhone" value="#form.ContactPhone#" />
			<cfinvokeargument name="Teaser" value="#form.Teaser#" />
			<cfinvokeargument name="Description" value="#form.Description#" />
		</cfinvoke>
		<cflocation url="#cgi.SCRIPT_NAME#?appAction=editRecord&EventID=#form.EventID#&returnMessage=#URLEncodedFormat(returnMessage)#" addtoken="false" />
		</cfsilent>
		</cfcase>
		
		
<!--- Processing --->
	<!--- Function createRecord --->
	<cffunction access="public" 
			name="createRecord" 
			output="false" 
			returntype="string" 
			displayname="createRecord" 
			hint="Adds a new database record. The return output is returnedMessage variable, a string message indicating success or failure.">
			
		<cfargument name="CategoryID" 
				type="numeric" 
				required="yes"
				default="1" 
				displayname="CategoryID" 
				hint="The category id the record belongs to." />
			
		<cfargument name="EventID" 
				type="string" 
				required="yes"
				displayname="EventID" 
				hint="The id of the item." />
			
		<cfargument name="IsPublished" 
				type="boolean" 
				required="false"
				default="0"
				displayname="IsPublished" 
				hint="Specificies if event should be published to the web site." />
			
		<cfargument name="IsFeatured" 
				type="boolean" 
				required="false"
				default="0"
				displayname="IsFeatured" 
				hint="Specificies if event should be published to the web site homepage." />
			
		<cfargument name="StartDate" 
				type="date" 
				required="true"
				displayname="StartDate" 
				hint="The start date of the record." />
			
		<cfargument name="EndDate" 
				type="date" 
				required="true"
				displayname="EndDate" 
				hint="The end date of the record." />
			
		<cfargument name="StartTime" 
				type="string" 
				required="yes"
				displayname="StartTime" 
				hint="The start time of the record." />
			
		<cfargument name="EndTime" 
				type="string" 
				required="no"
				displayname="EndTime" 
				hint="The ending time of the record." />
			
		<cfargument name="ContactPhone" 
				type="string" 
				required="true"
				displayname="ContactPhone" 
				hint="Contact phone number for the venue." />
			
		<cfargument name="ContactName" 
				type="string" 
				required="true"
				displayname="ContactName" 
				hint="Name of the event Contact Person." />
			
		<cfargument name="ContactEmail" 
				type="string" 
				required="true"
				displayname="ContactEmail" 
				hint="Contact person's email." />
				
		<cfargument name="Title" 
				type="string" 
				required="true" 
				displayname="Title" 
				hint="The title of the record." />
				
		<cfargument name="Location" 
				type="string" 
				required="true" 
				displayname="Location" 
				hint="Location for the event." />
				
		<cfargument name="Teaser" 
				type="string" 
				required="true" 
				displayname="Teaser" 
				hint="The teaser description." />
			
		<cfargument name="ExternalURL" 
				type="string" 
				required="true" 
				displayname="ExternalURL" 
				hint="A website address." />
			
		<cfargument name="Description" 
				type="string" 
				required="true"
				displayname="Description" 
				hint="The record contents." />	
		
		<cfset var returnMessage = "New record added." />
		
		<cfif NOT Len(Trim(arguments.EndDate))>
			<cfset arguments.EndDate = arguments.StartDate />
		</cfif>

		<!--- Add new record to table.--->
		
		<cfquery name="createRecord" datasource="#request.dsn#">
		
			INSERT INTO
				tblKalendar
				(
					CategoryID,
					IsPublished,
					IsFeatured,
					StartDate,
					EndDate, 
					StartTime, 
					EndTime,
					EventID,
					ContactPhone,
					ContactName,
					ContactEmail,
					Title,
					Location,
					Teaser,
					ExternalURL,
					Description
				)
			VALUES
				(
					<cfqueryparam cfsqltype="cf_sql_integer" value="#arguments.CategoryID#" />,
					<cfqueryparam cfsqltype="cf_sql_bit" value="#arguments.IsPublished#" />,
					<cfqueryparam cfsqltype="cf_sql_bit" value="#arguments.IsFeatured#" />,
					<cfqueryparam cfsqltype="cf_sql_date" value="#CreateODBCDate(arguments.StartDate)#" />,
					<cfqueryparam cfsqltype="cf_sql_date" value="#CreateODBCDate(arguments.EndDate)#" />, 
					<cfif Len(Trim(arguments.StartTime))><cfqueryparam cfsqltype="cf_sql_time" value="#CreateODBCTime(arguments.StartTime)#" /><cfelse>NULL</cfif>, 
					<cfif Len(Trim(arguments.EndTime))><cfqueryparam cfsqltype="cf_sql_time" value="#CreateODBCTime(arguments.EndTime)#" /><cfelse>NULL</cfif>,
					<cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.EventID#" />,
					<cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.ContactPhone)#" />,
					<cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.ContactName)#" />,
					<cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.ContactEmail)#" />,
					<cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.Title)#" />,
					<cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.Location)#" />,
					<cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.Teaser)#" />,
					<cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.ExternalURL)#" />,
					<cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.Description)#" />
				) 
				
		</cfquery>

		<cfreturn returnMessage />
				
	</cffunction>

	<!--- Function updateRecord --->
	<cffunction access="public" 
			name="updateRecord" 
			output="false" 
			returntype="string" 
			displayname="updateRecord" 
			hint="Updates a single database record based upon the ID sent. The return output is returnMessage variable, a string message indicating success or failure.">
			
		<cfargument name="EventID" 
				type="string" 
				required="true"
				displayname="EventID" 
				hint="The ID of the record to be updated." />
			
		<cfargument name="CategoryID" 
				type="numeric" 
				required="yes"
				default="1" 
				displayname="CategoryID" 
				hint="The category id the record belongs to." />
			
		<cfargument name="IsPublished" 
				type="boolean" 
				required="false"
				default="0"
				displayname="IsPublished" 
				hint="Specificies if event should be published to the web site." />
			
		<cfargument name="IsFeatured" 
				type="boolean" 
				required="false"
				default="0"
				displayname="IsFeatured" 
				hint="Specificies if event should be published to the web site homepage." />
			
		<cfargument name="IsDeleted" 
				type="boolean" 
				required="false"
				default="0"
				displayname="IsDeleted" 
				hint="Specificies if event should be deleted." />
			
		<cfargument name="StartDate" 
				type="date" 
				required="true"
				displayname="StartDate" 
				hint="The start date of the record." />
			
		<cfargument name="EndDate" 
				type="date" 
				required="true"
				displayname="EndDate" 
				hint="The end date of the record." />
			
		<cfargument name="StartTime" 
				type="string" 
				required="yes"
				displayname="StartTime" 
				hint="The start time of the record." />
			
		<cfargument name="EndTime" 
				type="string" 
				required="no"
				displayname="EndTime" 
				hint="The ending time of the record." />
			
		<cfargument name="ContactPhone" 
				type="string" 
				required="true"
				displayname="ContactPhone" 
				hint="Contact phone number for the venue." />
			
		<cfargument name="ContactName" 
				type="string" 
				required="true"
				displayname="ContactName" 
				hint="Name of the event Contact Person." />
			
		<cfargument name="ContactEmail" 
				type="string" 
				required="true"
				displayname="ContactEmail" 
				hint="Contact person's email." />
				
		<cfargument name="Title" 
				type="string" 
				required="true" 
				displayname="Title" 
				hint="The title of the record." />
				
		<cfargument name="Location" 
				type="string" 
				required="true" 
				displayname="Location" 
				hint="Location for the event." />
				
		<cfargument name="Teaser" 
				type="string" 
				required="true" 
				displayname="Teaser" 
				hint="The teaser description." />
			
		<cfargument name="ExternalURL" 
				type="string" 
				required="true" 
				displayname="ExternalURL" 
				hint="A website address." />
			
		<cfargument name="Description" 
				type="string" 
				required="true"
				displayname="Description" 
				hint="The record contents." />

		<cfset var returnMessage = "Record has been updated." />
		
		<!--- Update Record --->
		<cfif NOT Len(Trim(arguments.EndDate))>
			<cfset arguments.EndDate = arguments.StartDate />
		</cfif>
		
		<cfquery name="updateRecord" datasource="#request.dsn#">
		
			UPDATE
				tblKalendar
			SET
				CategoryID = <cfqueryparam cfsqltype="cf_sql_integer" value="#arguments.CategoryID#" />,
				IsPublished = <cfqueryparam cfsqltype="cf_sql_bit" value="#arguments.IsPublished#" />,
				IsFeatured = <cfqueryparam cfsqltype="cf_sql_bit" value="#arguments.IsFeatured#" />,
				IsDeleted = <cfqueryparam cfsqltype="cf_sql_bit" value="#arguments.IsDeleted#" />,
				StartDate = <cfqueryparam cfsqltype="cf_sql_date" value="#CreateODBCDate(arguments.StartDate)#" />,
				EndDate = <cfqueryparam cfsqltype="cf_sql_date" value="#CreateODBCDate(arguments.EndDate)#" />, 
				StartTime = <cfif Len(Trim(arguments.StartTime))><cfqueryparam cfsqltype="cf_sql_time" value="#CreateODBCTime(arguments.StartTime)#" /><cfelse>NULL</cfif>, 
				EndTime = <cfif Len(Trim(arguments.EndTime))><cfqueryparam cfsqltype="cf_sql_time" value="#CreateODBCTime(arguments.EndTime)#" /><cfelse>NULL</cfif>,
				ContactPhone = <cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.ContactPhone)#" />,
				ContactName = <cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.ContactName)#" />,
				ContactEmail = <cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.ContactEmail)#" />,
				Title = <cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.Title)#" />,
				Location = <cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.Location)#" />,
				Teaser = <cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.Teaser)#" />,
				ExternalURL = <cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.ExternalURL)#" />,
				Description = <cfqueryparam cfsqltype="cf_sql_varchar" value="#Trim(arguments.Description)#" />
			WHERE
				EventID = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.EventID#" />
			
		</cfquery>
		
		<cfreturn returnMessage />
				
	</cffunction>